Index: uspace/drv/bus/usb/ohci/utils/malloc32.h
===================================================================
--- uspace/drv/bus/usb/ohci/utils/malloc32.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/ohci/utils/malloc32.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -35,10 +35,8 @@
 #define DRV_OHCI_UTILS_MALLOC32_H
 
-#include <assert.h>
-#include <malloc.h>
-#include <unistd.h>
+#include <as.h>
 #include <errno.h>
-#include <mem.h>
-#include <as.h>
+#include <stdlib.h>
+#include <sys/types.h>
 
 /* Generic TDs and EDs require 16byte alignment,
Index: uspace/drv/bus/usb/uhci/Makefile
===================================================================
--- uspace/drv/bus/usb/uhci/Makefile	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/Makefile	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -31,4 +31,5 @@
 LIBS = \
 	$(LIBUSBHOST_PREFIX)/libusbhost.a \
+	$(LIBUSBVIRT_PREFIX)/libusbvirt.a \
 	$(LIBUSB_PREFIX)/libusb.a \
 	$(LIBDRV_PREFIX)/libdrv.a
@@ -36,5 +37,7 @@
 EXTRA_CFLAGS += \
 	-I$(LIBUSB_PREFIX)/include \
+	-I$(LIBUSBDEV_PREFIX)/include \
 	-I$(LIBUSBHOST_PREFIX)/include \
+	-I$(LIBUSBVIRT_PREFIX)/include \
 	-I$(LIBDRV_PREFIX)/include
 
@@ -44,9 +47,7 @@
 	hc.c \
 	main.c \
-	res.c \
-	root_hub.c \
 	transfer_list.c \
-	uhci.c \
 	uhci_batch.c \
+	uhci_rh.c \
 	hw_struct/transfer_descriptor.c
 
Index: uspace/drv/bus/usb/uhci/hc.c
===================================================================
--- uspace/drv/bus/usb/uhci/hc.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/hc.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -32,14 +32,24 @@
  * @brief UHCI Host controller driver routines
  */
+
+#include <adt/list.h>
+#include <assert.h>
+#include <async.h>
+#include <ddi.h>
+#include <device/hw_res_parsed.h>
+#include <fibril.h>
 #include <errno.h>
+#include <macros.h>
+#include <mem.h>
+#include <stdlib.h>
 #include <str_error.h>
-#include <adt/list.h>
-#include <ddi.h>
+#include <sys/types.h>
 
 #include <usb/debug.h>
 #include <usb/usb.h>
 
+#include "uhci_batch.h"
+#include "utils/malloc32.h"
 #include "hc.h"
-#include "uhci_batch.h"
 
 #define UHCI_INTR_ALLOW_INTERRUPTS \
@@ -85,87 +95,52 @@
 static int hc_init_mem_structures(hc_t *instance);
 static int hc_init_transfer_lists(hc_t *instance);
-static int hc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch);
 
 static int hc_interrupt_emulator(void *arg);
 static int hc_debug_checker(void *arg);
 
-enum {
-	/** Number of PIO ranges used in IRQ code */
-	hc_irq_pio_range_count =
-	    sizeof(uhci_irq_pio_ranges) / sizeof(irq_pio_range_t),
-
-	/* Number of commands used in IRQ code */
-	hc_irq_cmd_count =
-	    sizeof(uhci_irq_commands) / sizeof(irq_cmd_t)
-};
 
 /** Generate IRQ code.
- * @param[out] ranges PIO ranges buffer.
- * @param[in] ranges_size Size of the ranges buffer (bytes).
- * @param[out] cmds Commands buffer.
- * @param[in] cmds_size Size of the commands buffer (bytes).
- * @param[in] regs Device's register range.
+ * @param[out] code IRQ code structure.
+ * @param[in] hw_res Device's resources.
  *
  * @return Error code.
  */
-int
-hc_get_irq_code(irq_pio_range_t ranges[], size_t ranges_size, irq_cmd_t cmds[],
-    size_t cmds_size, addr_range_t *regs)
-{
-	if ((ranges_size < sizeof(uhci_irq_pio_ranges)) ||
-	    (cmds_size < sizeof(uhci_irq_commands)) ||
-	    (RNGSZ(*regs) < sizeof(uhci_regs_t)))
+int hc_gen_irq_code(irq_code_t *code, const hw_res_list_parsed_t *hw_res)
+{
+	assert(code);
+	assert(hw_res);
+
+	if (hw_res->irqs.count != 1 || hw_res->io_ranges.count != 1)
+		return EINVAL;
+	const addr_range_t regs = hw_res->io_ranges.ranges[0];
+
+	if (RNGSZ(regs) < sizeof(uhci_regs_t))
 		return EOVERFLOW;
 
-	memcpy(ranges, uhci_irq_pio_ranges, sizeof(uhci_irq_pio_ranges));
-	ranges[0].base = RNGABS(*regs);
-
-	memcpy(cmds, uhci_irq_commands, sizeof(uhci_irq_commands));
-	uhci_regs_t *registers = (uhci_regs_t *) RNGABSPTR(*regs);
-	cmds[0].addr = &registers->usbsts;
-	cmds[3].addr = &registers->usbsts;
-
-	return EOK;
-}
-
-/** Register interrupt handler.
- *
- * @param[in] device Host controller DDF device
- * @param[in] regs Register range
- * @param[in] irq Interrupt number
- * @paran[in] handler Interrupt handler
- *
- * @return EOK on success or negative error code
- */
-int hc_register_irq_handler(ddf_dev_t *device, addr_range_t *regs, int irq,
-    interrupt_handler_t handler)
-{
-	int rc;
-	irq_pio_range_t irq_ranges[hc_irq_pio_range_count];
-	irq_cmd_t irq_cmds[hc_irq_cmd_count];
-	rc = hc_get_irq_code(irq_ranges, sizeof(irq_ranges), irq_cmds,
-	    sizeof(irq_cmds), regs);
-	if (rc != EOK) {
-		usb_log_error("Failed to generate IRQ commands: %s.\n",
-		    str_error(rc));
-		return rc;
-	}
-
-	irq_code_t irq_code = {
-		.rangecount = hc_irq_pio_range_count,
-		.ranges = irq_ranges,
-		.cmdcount = hc_irq_cmd_count,
-		.cmds = irq_cmds
-	};
-
-        /* Register handler to avoid interrupt lockup */
-        rc = register_interrupt_handler(device, irq, handler, &irq_code);
-        if (rc != EOK) {
-    		usb_log_error("Failed to register interrupt handler: %s.\n",
-    		    str_error(rc));
-    		return rc;
-    	}
-
-	return EOK;
+	code->ranges = malloc(sizeof(uhci_irq_pio_ranges));
+	if (code->ranges == NULL)
+		return ENOMEM;
+
+	code->cmds = malloc(sizeof(uhci_irq_commands));
+	if (code->cmds == NULL) {
+		free(code->ranges);
+		return ENOMEM;
+	}
+
+	code->rangecount = ARRAY_SIZE(uhci_irq_pio_ranges);
+	code->cmdcount = ARRAY_SIZE(uhci_irq_commands);
+
+	memcpy(code->ranges, uhci_irq_pio_ranges, sizeof(uhci_irq_pio_ranges));
+	code->ranges[0].base = RNGABS(regs);
+
+	memcpy(code->cmds, uhci_irq_commands, sizeof(uhci_irq_commands));
+	uhci_regs_t *registers = (uhci_regs_t *) RNGABSPTR(regs);
+	code->cmds[0].addr = (void*)&registers->usbsts;
+	code->cmds[3].addr = (void*)&registers->usbsts;
+
+	usb_log_debug("I/O regs at %p (size %zu), IRQ %d.\n",
+	    RNGABSPTR(regs), RNGSZ(regs), hw_res->irqs.irqs[0]);
+
+	return hw_res->irqs.irqs[0];
 }
 
@@ -195,9 +170,8 @@
 		    &instance->transfers_bulk_full, &done);
 
-		while (!list_empty(&done)) {
-			link_t *item = list_first(&done);
-			list_remove(item);
+		list_foreach_safe(done, current, next) {
+			list_remove(current);
 			uhci_transfer_batch_t *batch =
-			    uhci_transfer_batch_from_link(item);
+			    uhci_transfer_batch_from_link(current);
 			uhci_transfer_batch_finish_dispose(batch);
 		}
@@ -238,8 +212,11 @@
  * interrupt fibrils.
  */
-int hc_init(hc_t *instance, addr_range_t *regs, bool interrupts)
-{
-	assert(regs->size >= sizeof(uhci_regs_t));
-	int rc;
+int hc_init(hc_t *instance, const hw_res_list_parsed_t *hw_res, bool interrupts)
+{
+	assert(instance);
+	assert(hw_res);
+	if (hw_res->io_ranges.count != 1 ||
+	    hw_res->io_ranges.ranges[0].size < sizeof(uhci_regs_t))
+	    return EINVAL;
 
 	instance->hw_interrupts = interrupts;
@@ -247,29 +224,23 @@
 
 	/* allow access to hc control registers */
-	uhci_regs_t *io;
-	rc = pio_enable_range(regs, (void **) &io);
-	if (rc != EOK) {
-		usb_log_error("Failed to gain access to registers at %p: %s.\n",
-		    io, str_error(rc));
-		return rc;
-	}
-
-	instance->registers = io;
-	usb_log_debug(
-	    "Device registers at %p (%zuB) accessible.\n", io, regs->size);
-
-	rc = hc_init_mem_structures(instance);
-	if (rc != EOK) {
-		usb_log_error("Failed to initialize UHCI memory structures: %s.\n",
-		    str_error(rc));
-		return rc;
-	}
-
-	hcd_init(&instance->generic, USB_SPEED_FULL,
-	    BANDWIDTH_AVAILABLE_USB11, bandwidth_count_usb11);
-
-	instance->generic.private_data = instance;
-	instance->generic.schedule = hc_schedule;
-	instance->generic.ep_add_hook = NULL;
+	int ret = pio_enable_range(&hw_res->io_ranges.ranges[0],
+	    (void **) &instance->registers);
+	if (ret != EOK) {
+		usb_log_error("Failed to gain access to registers: %s.\n",
+	            str_error(ret));
+		return ret;
+	}
+
+	usb_log_debug("Device registers at %" PRIx64 " (%zuB) accessible.\n",
+	    hw_res->io_ranges.ranges[0].address.absolute,
+	    hw_res->io_ranges.ranges[0].size);
+
+	ret = hc_init_mem_structures(instance);
+	if (ret != EOK) {
+		usb_log_error("Failed to init UHCI memory structures: %s.\n",
+		    str_error(ret));
+		// TODO: we should disable pio here
+		return ret;
+	}
 
 	hc_init_hw(instance);
@@ -281,5 +252,17 @@
 	(void)hc_debug_checker;
 
+	uhci_rh_init(&instance->rh, instance->registers->ports, "uhci");
+
 	return EOK;
+}
+
+/** Safely dispose host controller internal structures
+ *
+ * @param[in] instance Host controller structure to use.
+ */
+void hc_fini(hc_t *instance)
+{
+	assert(instance);
+	//TODO Implement
 }
 
@@ -440,7 +423,11 @@
 {
 	assert(hcd);
-	hc_t *instance = hcd->private_data;
+	hc_t *instance = hcd->driver.data;
 	assert(instance);
 	assert(batch);
+
+	if (batch->ep->address == uhci_rh_get_address(&instance->rh))
+		return uhci_rh_schedule(&instance->rh, batch);
+
 	uhci_transfer_batch_t *uhci_batch = uhci_transfer_batch_get(batch);
 	if (!uhci_batch) {
Index: uspace/drv/bus/usb/uhci/hc.h
===================================================================
--- uspace/drv/bus/usb/uhci/hc.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/hc.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -36,15 +36,20 @@
 #define DRV_UHCI_HC_H
 
-#include <ddf/interrupt.h>
 #include <device/hw_res_parsed.h>
 #include <fibril.h>
+#include <macros.h>
+#include <stdbool.h>
+#include <sys/types.h>
 #include <usb/host/hcd.h>
+#include <usb/host/usb_transfer_batch.h>
 
+#include "uhci_rh.h"
 #include "transfer_list.h"
+#include "hw_struct/link_pointer.h"
 
 /** UHCI I/O registers layout */
 typedef struct uhci_regs {
 	/** Command register, controls HC behaviour */
-	uint16_t usbcmd;
+	ioport16_t usbcmd;
 #define UHCI_CMD_MAX_PACKET (1 << 7)
 #define UHCI_CMD_CONFIGURE  (1 << 6)
@@ -57,5 +62,5 @@
 
 	/** Status register, 1 means interrupt is asserted (if enabled) */
-	uint16_t usbsts;
+	ioport16_t usbsts;
 #define UHCI_STATUS_HALTED (1 << 5)
 #define UHCI_STATUS_PROCESS_ERROR (1 << 4)
@@ -68,5 +73,5 @@
 
 	/** Interrupt enabled registers */
-	uint16_t usbintr;
+	ioport16_t usbintr;
 #define UHCI_INTR_SHORT_PACKET (1 << 3)
 #define UHCI_INTR_COMPLETE (1 << 2)
@@ -75,11 +80,14 @@
 
 	/** Register stores frame number used in SOF packet */
-	uint16_t frnum;
+	ioport16_t frnum;
 
 	/** Pointer(physical) to the Frame List */
-	uint32_t flbaseadd;
+	ioport32_t flbaseadd;
 
 	/** SOF modification to match external timers */
-	uint8_t sofmod;
+	ioport8_t sofmod;
+
+	PADD8[3];
+	ioport16_t ports[];
 } uhci_regs_t;
 
@@ -92,7 +100,5 @@
 /** Main UHCI driver structure */
 typedef struct hc {
-	/** Generic HCD driver structure */
-	hcd_t generic;
-
+	uhci_rh_t rh;
 	/** Addresses of I/O registers */
 	uhci_regs_t *registers;
@@ -121,16 +127,10 @@
 } hc_t;
 
-int hc_register_irq_handler(ddf_dev_t *, addr_range_t *, int,
-    interrupt_handler_t);
-int hc_get_irq_code(irq_pio_range_t [], size_t, irq_cmd_t [], size_t,
-    addr_range_t *);
+int hc_gen_irq_code(irq_code_t *code, const hw_res_list_parsed_t *hw_res);
 void hc_interrupt(hc_t *instance, uint16_t status);
-int hc_init(hc_t *instance, addr_range_t *regs, bool interupts);
+int hc_init(hc_t *instance, const hw_res_list_parsed_t *hw_res, bool interupts);
+void hc_fini(hc_t *instance);
+int hc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch);
 
-/** Safely dispose host controller internal structures
- *
- * @param[in] instance Host controller structure to use.
- */
-static inline void hc_fini(hc_t *instance) {} /* TODO: implement*/
 #endif
 
Index: uspace/drv/bus/usb/uhci/hw_struct/link_pointer.h
===================================================================
--- uspace/drv/bus/usb/uhci/hw_struct/link_pointer.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/hw_struct/link_pointer.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -35,4 +35,6 @@
 #define DRV_UHCI_HW_STRUCT_LINK_POINTER_H
 
+#include <sys/types.h>
+
 /** UHCI link pointer, used by many data structures */
 typedef uint32_t link_pointer_t;
Index: uspace/drv/bus/usb/uhci/hw_struct/queue_head.h
===================================================================
--- uspace/drv/bus/usb/uhci/hw_struct/queue_head.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/hw_struct/queue_head.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -34,5 +34,7 @@
 #ifndef DRV_UHCI_HW_STRUCT_QH_H
 #define DRV_UHCI_HW_STRUCT_QH_H
+
 #include <assert.h>
+#include <sys/types.h>
 
 #include "link_pointer.h"
Index: uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.c
===================================================================
--- uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -32,7 +32,12 @@
  * @brief UHCI driver
  */
+
+#include <assert.h>
 #include <errno.h>
+
 #include <usb/debug.h>
+#include <usb/usb.h>
 
+#include "link_pointer.h"
 #include "transfer_descriptor.h"
 #include "../utils/malloc32.h"
Index: uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.h
===================================================================
--- uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/hw_struct/transfer_descriptor.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -35,6 +35,8 @@
 #define DRV_UHCI_HW_STRUCT_TRANSFER_DESCRIPTOR_H
 
-#include <mem.h>
+#include <assert.h>
 #include <usb/usb.h>
+#include <stdbool.h>
+#include <sys/types.h>
 
 #include "link_pointer.h"
Index: uspace/drv/bus/usb/uhci/main.c
===================================================================
--- uspace/drv/bus/usb/uhci/main.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/main.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -26,5 +26,5 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup drvusbuhcihc
+/** @addtogroup drvusbuhci
  * @{
  */
@@ -32,25 +32,86 @@
  * @brief UHCI driver initialization
  */
+
+#include <assert.h>
 #include <ddf/driver.h>
+#include <devman.h>
 #include <errno.h>
+#include <io/log.h>
+#include <pci_dev_iface.h>
+#include <stdio.h>
 #include <str_error.h>
+#include <usb/debug.h>
+#include <usb/host/ddf_helpers.h>
 
-#include <usb/ddfiface.h>
-#include <usb/debug.h>
-
-#include "uhci.h"
+#include "hc.h"
 
 #define NAME "uhci"
 
+// TODO: This should be merged to hc_interrupt
+static void uhci_interrupt(hcd_t *hcd, uint32_t status)
+{
+	assert(hcd);
+	if (hcd->driver.data)
+		hc_interrupt(hcd->driver.data, status);
+}
+
+static int uhci_driver_init(hcd_t *hcd, const hw_res_list_parsed_t *res, bool irq)
+{
+	assert(hcd);
+	assert(hcd->driver.data == NULL);
+
+	hc_t *instance = malloc(sizeof(hc_t));
+	if (!instance)
+		return ENOMEM;
+
+	const int ret =  hc_init(instance, res, irq);
+	if (ret == EOK)
+		hcd_set_implementation(hcd, instance, hc_schedule, NULL, NULL,
+		    uhci_interrupt);
+	return ret;
+}
+
+static void uhci_driver_fini(hcd_t *hcd)
+{
+	assert(hcd);
+	if (hcd->driver.data)
+		hc_fini(hcd->driver.data);
+
+	free(hcd->driver.data);
+	hcd_set_implementation(hcd, NULL, NULL, NULL, NULL, NULL);
+}
+
 static int uhci_dev_add(ddf_dev_t *device);
 
-static driver_ops_t uhci_driver_ops = {
+static const driver_ops_t uhci_driver_ops = {
 	.dev_add = uhci_dev_add,
 };
 
-static driver_t uhci_driver = {
+static const driver_t uhci_driver = {
 	.name = NAME,
 	.driver_ops = &uhci_driver_ops
 };
+
+/** Call the PCI driver with a request to clear legacy support register
+ *
+ * @param[in] device Device asking to disable interrupts
+ * @return Error code.
+ */
+static int disable_legacy(ddf_dev_t *device)
+{
+	assert(device);
+
+	async_sess_t *parent_sess = devman_parent_device_connect(
+	    EXCHANGE_SERIALIZE, ddf_dev_get_handle(device), IPC_FLAG_BLOCKING);
+	if (!parent_sess)
+		return ENOMEM;
+
+	/* See UHCI design guide page 45 for these values.
+	 * Write all WC bits in USB legacy register */
+	const int rc = pci_config_space_write_16(parent_sess, 0xc0, 0xaf00);
+
+	async_hangup(parent_sess);
+	return rc;
+}
 
 /** Initialize a new ddf driver instance for uhci hc and hub.
@@ -64,5 +125,16 @@
 	assert(device);
 
-	const int ret = device_setup_uhci(device);
+	int ret = disable_legacy(device);
+	if (ret != EOK) {
+		usb_log_error("Failed to disable legacy USB: %s.\n",
+		    str_error(ret));
+		return ret;
+	}
+
+
+	ret = ddf_hcd_device_setup_all(device, USB_SPEED_FULL,
+	    BANDWIDTH_AVAILABLE_USB11, bandwidth_count_usb11,
+	    ddf_hcd_gen_irq_handler, hc_gen_irq_code,
+	    uhci_driver_init, uhci_driver_fini);
 	if (ret != EOK) {
 		usb_log_error("Failed to initialize UHCI driver: %s.\n",
Index: uspace/drv/bus/usb/uhci/transfer_list.c
===================================================================
--- uspace/drv/bus/usb/uhci/transfer_list.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/transfer_list.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -34,8 +34,13 @@
  */
 
+#include <assert.h>
 #include <errno.h>
+#include <libarch/barrier.h>
+#include <sys/types.h>
 #include <usb/debug.h>
-#include <libarch/barrier.h>
-
+#include <usb/host/usb_transfer_batch.h>
+
+#include "utils/malloc32.h"
+#include "hw_struct/link_pointer.h"
 #include "transfer_list.h"
 
Index: uspace/drv/bus/usb/uhci/transfer_list.h
===================================================================
--- uspace/drv/bus/usb/uhci/transfer_list.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/transfer_list.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -35,4 +35,5 @@
 #define DRV_UHCI_TRANSFER_LIST_H
 
+#include <adt/list.h>
 #include <fibril_synch.h>
 
Index: uspace/drv/bus/usb/uhci/uhci_batch.c
===================================================================
--- uspace/drv/bus/usb/uhci/uhci_batch.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/uhci_batch.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -32,13 +32,16 @@
  * @brief UHCI driver USB transfer structure
  */
+
+#include <assert.h>
 #include <errno.h>
-#include <str_error.h>
 #include <macros.h>
+#include <mem.h>
+#include <stdlib.h>
 
 #include <usb/usb.h>
 #include <usb/debug.h>
+#include <usb/host/endpoint.h>
 
 #include "uhci_batch.h"
-#include "transfer_list.h"
 #include "hw_struct/transfer_descriptor.h"
 #include "utils/malloc32.h"
@@ -67,4 +70,5 @@
 	assert(uhci_batch);
 	assert(uhci_batch->usb_batch);
+	assert(!link_in_use(&uhci_batch->link));
 	usb_transfer_batch_finish(uhci_batch->usb_batch,
 	    uhci_transfer_batch_data_buffer(uhci_batch));
Index: uspace/drv/bus/usb/uhci/uhci_batch.h
===================================================================
--- uspace/drv/bus/usb/uhci/uhci_batch.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/uhci/uhci_batch.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -35,6 +35,10 @@
 #define DRV_UHCI_BATCH_H
 
+#include <adt/list.h>
+#include <assert.h>
+#include <errno.h>
+#include <stdbool.h>
+#include <sys/types.h>
 #include <usb/host/usb_transfer_batch.h>
-#include <adt/list.h>
 
 #include "hw_struct/queue_head.h"
